//
//
//  class devmixer :- abstracts I/O from the mixer device
// 
//  written by Simon Aldrich (simon@simonaldrich.co.uk) 
//
//////////////////////////////////////////////////////////////////

#ifndef DEVMIXER_H
#define DEVMIXER_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/soundcard.h>

class devmixer
{
public:
	devmixer(char *mixerdevice);
	virtual ~devmixer();
	
	// output the current mixer settings to stdout
	int save_mixer_settings();
	// output the current mixer settings to a file
	int save_mixer_settings(char *filename);
	// read new mixer settings from a file
	int load_mixer_settings(char *filename);
	
	int enum_outchannels();
	int enum_inchannels();	
		
	int get_mixer_level(int channel);
	int set_mixer_level(int channel, char left, char right);
	int set_mixer_level(char *channel, char left, char right);
	
	int get_rec_channel();
	int set_rec_channel(int channel);
	int set_rec_channel(char *channel);

private:
	int m_devmixer;
	int m_outmask, m_inmask, m_stereomask;
	
	int init_mixer();
	int getcvstring(char *source, char *dest, int start);

};

#endif
